// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef _DEFENCE_BREAKER_H
#define _DEFENCE_BREAKER_H

#include "HelliBASH09Pass.h"

#include <rcsc/geom/vector_2d.h>
#include <rcsc/geom/polygon_2d.h>
#include <rcsc/player/player_agent.h>

#include <string>

class DefenceBreaker
{
private:
	float mDelay;
	std::string players;
	std::string tmpOpenPlayers;
	int playerDelay[11];
	float getMaxDelay(rcsc::PlayerAgent *agent);
	void setMaxPossibleDelay(rcsc::PlayerAgent *agent);
	float maxPossibleDelay;
	float oppKickable;
	float oppCatchable;
	float maxDistanceToOffsideLine;

	static int finalCycle;

	HelliBASH09Pass dfbPass;
	bool isPassSetThisCycle;
	bool isPassPossible;

public:
	DefenceBreaker();
	~DefenceBreaker();
	void reset();
	void setReceiverPlayers(std::string openPlayers);
	void setMaxDistanceToOffsideLine(float max);
	void setOppControlBuff(float kickable, float catchable);
	bool isAvailable(rcsc::PlayerAgent *agent);
	void execute(rcsc::PlayerAgent *agent);
	bool shouldHoldBall(rcsc::PlayerAgent *agent);
	bool shouldPass(rcsc::PlayerAgent *agent);
	void doHoldBall(rcsc::PlayerAgent *agent);
	void doKickBall(rcsc::PlayerAgent *agent);
	bool areWeInTheMiddle(rcsc::PlayerAgent *agent);
};

#endif // Defence Breaker
