// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#include <GlobalPositioning.h>
#include <Share.h>

using namespace rcsc;
using namespace std;

int GlobalPositioning::positionStyle = -1;
vector<PositioningConfig> GlobalPositioning::posConfs;
	
GlobalPositioning::GlobalPositioning(int style)
{
	if ( positionStyle != style )
	{
		positionStyle = style;
		posConfs.clear();
		string addr = "Positioning ";
		addr[addr.length() - 1] = (char)(style + 48);
		for ( unsigned int i = 0; i < CONFIG[addr]["PositioningConfig"].size(); i++)
		{
			posConfs.push_back(PositioningConfig(CONFIG[addr]["PositioningConfig"][i]));
		}
	}

}

Vector2D GlobalPositioning::getHomePos(const rcsc::WorldModel *wm)
{
	Vector2D pos(-1000,-1000);
	unsigned int i = 0;
	while ( ( i < posConfs.size() ) and ( pos.x < -100 ) )
	{
		pos = posConfs[i].getHomePos(wm);
		i++;
	}
	return pos;
}
