// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef _HELLIBASH_09_SRP_H
#define _HELLIBASH_09_SRP_H

#include <rcsc/geom/vector_2d.h>
#include <rcsc/geom/polygon_2d.h>
#include <rcsc/player/player_agent.h>

class HelliBASH09SRP
{
private:
	rcsc::Vector2D mTarget;
	float bestRate;
	float ballMovement;
	float maxForwardMovement;
	bool hasForbiddenPolygon;
	rcsc::Polygon2D mForbiddenPolygon;
	float maxVisionDelay;


	float getCycleBeforeExit(rcsc::PlayerAgent *agent,float curRate);
	float getOthersMinReachCycle(rcsc::PlayerAgent *agent,float curRate);
	float getMyReachCycle(rcsc::PlayerAgent *agent,float curRate);
	float isGood(rcsc::PlayerAgent *agent,float curRate);
	float othersKickable,othersMaxDash;
	float myKickable,myMaxDash;
	
	static int lastKickCycle;

public:
	HelliBASH09SRP(rcsc::Vector2D target);
	HelliBASH09SRP();
	void reconstruct(rcsc::Vector2D target);
	~HelliBASH09SRP();
	void setSafetyValues(float _myKickable,float _myMaxDash,float _othersKickable,float _othersMaxDash);
	void setHasForbiddenPolygon(bool b);
	void setMaxForwardMovement(float max);
	void setMaxVisionDelay(float max);
	rcsc::Polygon2D & forbiddenPolygon();
	bool getValue(rcsc::PlayerAgent *agent);
	float getBallMovement();
	void execute(rcsc::PlayerAgent *agent);
	bool shouldIntercept(rcsc::PlayerAgent *agent);
	void reset();
};

#endif // _HELLIBASH_09_SRP_H
