// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#include <LookToPlayerAndBall.h>

#include <rcsc/action/view_normal.h>
#include <rcsc/action/neck_turn_to_point.h>
#include <rcsc/action/neck_turn_to_ball.h>

#include <rcsc/common/logger.h>

#include <Basics.h>
#include <Share.h>

using namespace Basics;
using namespace rcsc;

LookToPlayerAndBall::LookToPlayerAndBall(const PlayerObject* _player):
	player(_player)
{
}

bool LookToPlayerAndBall::execute(PlayerAgent* agent)
{
	if (isInPlayers(agent->world().self().unum(), "234578"))
		Share::markLookMode = true;

	if (player->posCount() == 0)
	{
		agent->setNeckAction( new Neck_TurnToBall() );
		dlog.addText(Logger::MARK, "Looking to BALL");
		return true;
	}

	switch (agent->world().time().cycle() % 2)
	{
		case 0:
			agent->setNeckAction( new Neck_TurnToBall() );

			dlog.addText(Logger::MARK, "Looking to BALL");
			break;
		case 1:
			Vector2D playerNextPos = player->pos() + player->vel();

			agent->setNeckAction( new Neck_TurnToPoint(playerNextPos) );

			dlog.addText(Logger::MARK, "Looking to PLAYER (%f, %f)", playerNextPos.x, playerNextPos.y);
			break;
	}

	return true;
}
