// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////
#include <PenaltyShoot.h>

#include <Share.h>
#include <rcsc/common/logger.h>
#include <rcsc/common/server_param.h>

#include <rcsc/player/abstract_player_object.h>
#include <rcsc/player/penalty_kick_state.h>
#include <rcsc/player/intercept_table.h>
#include <rcsc/player/player_agent.h>

#include <rcsc/action/basic_actions.h>
#include <rcsc/action/body_go_to_point.h>
#include <rcsc/action/body_turn_to_point.h>
#include <rcsc/action/body_kick_one_step.h>

#include <FastIC.h>
#include <Basics.h>
#include <Degree.h>

#include <body_go_to_point2008.h>

using namespace rcsc;
using namespace std;
using namespace Basics;

PenaltyShoot::PenaltyShoot( )
{
}

bool
PenaltyShoot::execute( PlayerAgent * agent )
{
	dlog.addText( Logger::BLOCK, "Entering PenaltyShoot");
	if ( !agent->world().self().isKickable() )
	{
		dlog.addText( Logger::BLOCK, "Ball is not kickable");
		return false;
	}

	dlog.addText( Logger::BLOCK, "ball is kickable for shoot");dlog.flush();
	const WorldModel & wm = agent->world();
	const rcsc::PenaltyKickState * state = agent->world().penaltyKickState();
	Vector2D center_goal(-52.5, 0);
	const Vector2D myPos = wm.self().pos();
	if ( agent->world().gameMode().isPenaltyKickMode() and state->onfieldSide() != agent->world().ourSide() )
		center_goal = Vector2D(52.5 ,0);

	dlog.addText( Logger::BLOCK, "center_goal is %f, %f", center_goal.x, center_goal.y);dlog.flush();

	FastIC fastIC;
	Vector2D ballPos = wm.ball().pos();
	double * dist;
	int thr = 1;
	//const PlayerObject * player = wm.getTeammateNearestTo(myPos, thr, dist);
	//dlog.addText( Logger::BLOCK, "myPos is %f, %f ?", player->pos().x, player->pos().y);
	//dlog.addText( Logger::BLOCK, "players.size() = %d", fastIC.players().size());dlog.flush();

//	FastPlayer( int _delay , bool _isTeamMate, float _controlBuff , float _dashMultiplier ,const rcsc::PlayerObject* _playerPtr )
	fastIC.reconstruct();
	FastPlayer fastplayer(1, true, 1.1, 1.0, NULL);
	const PlayerObject * opp_goalie = wm.getOpponentGoalie();

	if (opp_goalie)
	{
		double controlBuff = 3;
		int delay = 2;
		if (opp_goalie->pos().dist(myPos) < 5)
			controlBuff = 1.65;
		fastplayer = FastPlayer(delay, false, controlBuff, 1.0, wm.getOpponentGoalie());
		fastIC.players().push_back(fastplayer);
	}
	else
		return false;
	//FastPlayer fastself(1, true, 1.1, 1.0, player);
//	fastIC.resetPlayers();
	//fastIC.players().push_back( fastself );

	vector <PenaltyShootModel> Shoots;
	int ballDelay = 0;

	double min;
	double plus;
//	if ( myPos.dist(center_goal) < 25 )
	{
		min = 6.4;
		plus = 0.8;
	}
//	else
//	{
//		min = 5.2;
//		plus = 2.6;
//	}

	dlog.addText( Logger::BLOCK, "HEYEEEEE!!");dlog.flush();
	if ( wm.ball().vel().r() > 1.0 )
	{
		dlog.addText( Logger::BLOCK, "wm.ball().vel().r() > 1.0, so set ball delay to 1 and use multiStepKick");dlog.flush();
	}

	for (double y = center_goal.y - min; y <= center_goal.y + min ; y += plus)
	{
		//dlog.addText( Logger::BLOCK, "111");dlog.flush();
		fastIC.players()[0].delay = 2;
		Vector2D endBallPos(center_goal.x, y);
		dlog.addText( Logger::BLOCK, "endBallPos is %f, %f", endBallPos.x, endBallPos.y);
		vector <FastestPlayer> fastestplayers;
		Vector2D BVel;
		AngleDeg Dir = Ray2D(ballPos, endBallPos).dir();
		double maxSpeed = Body_KickOneStep::get_max_possible_vel(Dir, wm.self().kickRate(), wm.ball().vel()).r();
		BVel.setPolar(maxSpeed, Dir);
		dlog.addText( Logger::BLOCK, "ball Dir is %f", Dir.degree());
		dlog.addText( Logger::BLOCK, "BVel is %f, %f", BVel.x, BVel.y);
		dlog.addText( Logger::BLOCK, "Diff = %f", Degree::getDegree(endBallPos, ballPos, fastIC.players()[0].mPos));
		if (fastIC.players()[0].mPos.dist(myPos) < 3)
			fastIC.players()[0].delay++;
		if (fabs(Degree::getDegree(endBallPos, ballPos, fastIC.players()[0].mPos)) < 30)
			fastIC.players()[0].delay = 0;
		dlog.addText( Logger::BLOCK, "Delay = %d", fastIC.players()[0].delay);
		fastIC.setBall(ballPos , BVel, ballDelay);
		fastIC.calculate(wm.self().unum(), 0, true);
		fastestplayers = fastIC.getFastestPlayers();
		//dlog.addText( Logger::BLOCK, "131");dlog.flush();
		dlog.addText( Logger::BLOCK, "players.size() = %d", fastIC.players().size());
		dlog.addText( Logger::BLOCK, "fastestplayers.size() = %d", fastIC.getFastestPlayers().size());
		if (fastestplayers.size() > 0)
			dlog.addText( Logger::BLOCK, "fastestReachCycle is %d", fastestplayers[0].reachCycle);
		if (fastestplayers.size() > 1)
			dlog.addText( Logger::BLOCK, "fastest2ReachCycle is %d", fastestplayers[1].reachCycle);
		if (fastestplayers.size() > 1)
			dlog.addText( Logger::BLOCK, "fastest unum is %d \t and is TeamMate is %d", fastestplayers[0].unum, fastestplayers[0].isTeamMate);
		if (fastestplayers.size() > 1)
			dlog.addText( Logger::BLOCK, "fastest2 unum is %d \t and is TeamMate is %d", fastestplayers[1].unum, fastestplayers[1].isTeamMate);
		if (fastestplayers.size() == 0)
		{
			dlog.addText( Logger::BLOCK, "Shoots.push_back()");//dlog.flush();
			Shoots.push_back(PenaltyShootModel(endBallPos, maxSpeed));
			continue;
		}
		//dlog.addText( Logger::BLOCK, "151");dlog.flush();
		double fastestReachCycle = fastestplayers[0].reachCycle;
		Vector2D fastestReachPoint = wm.ball().inertiaPoint(fastestReachCycle);
		//dlog.addText( Logger::BLOCK, "161");dlog.flush();
		if(fastestplayers[0].unum == wm.self().unum() and fastestplayers[0].isTeamMate == true)
		{
			dlog.addText( Logger::BLOCK, "Shoots.push_back()");
			Shoots.push_back(PenaltyShootModel(endBallPos, maxSpeed));
		}
		dlog.addText( Logger::BLOCK, "==========================");//dlog.flush();
	}

	dlog.addText( Logger::BLOCK, "Shoots.size() = %d", Shoots.size());

	if (Shoots.size() > 0 and wm.getOpponentGoalie() and wm.getOpponentGoalie()->posCount() < 4)
	{
		Vector2D target_point;
		double minAbsY = 100;
		for (uint i = 0; i < Shoots.size(); i++)
		{
			if (Shoots[i].target.absY() < minAbsY)
			{
				target_point = Shoots[i].target;
				minAbsY = target_point.absY();
			}
		}

		dlog.addText( Logger::BLOCK, "shoot value is true");
		dlog.addText( Logger::BLOCK, "target_point is %f, %f", target_point.x, target_point.y);
		dlog.addText( Logger::BLOCK, "wm.ball().vel().r() is %f", wm.ball().vel().r());
		return Body_KickOneStep( target_point, 3).execute(agent);
	}
	
	return false;
}
