// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef _BLOCK_H
#define _BLOCK_H

#include <rcsc/geom/vector_2d.h>
#include <rcsc/geom/ray_2d.h>
#include <rcsc/geom/rect_2d.h>
#include <rcsc/geom/angle_deg.h>
#include <rcsc/geom/polygon_2d.h>
#include <rcsc/player/player_agent.h>
#include <rcsc/player/world_model.h>
#include <rcsc/player/ball_object.h>

#include <map>
#include <vector>
#include <cstring>
#include <Basics.h>

using namespace std;
using namespace rcsc;

class Block
{
private:

    PlayerAgent * agent;
	vector <Vector2D> oppRoutePoints;
	vector <Vector2D> targets;

	Vector2D oppRoutePoint;
	Line2D oppRouteLine;
	Ray2D oppRouteRay;

	const AbstractPlayerObject * fastestOpp;
	Vector2D fastestOppPos;
	Vector2D ballPos;
	Vector2D myPos;

	const PenaltyKickState * state;

	static const double min_vel = 0.15;

	int N;

public:

    Block( );
    bool execute( PlayerAgent * agent );

private:

	bool isNearToBall( Vector2D BallPos );
	void getBall();
	void goCloseToBall();

	Vector2D getOppRoute();
	Vector2D getOppRoute_Penalty();

	void setOppRoutesInDangerField();
	void setOppRoutesInOtherPlaces();
	void setValidPoints();
	void sideDashGetBall( bool chengeBody = true );
	void goCloseToReceivePoint();

	bool LookToBallAndPlayer(const AbstractPlayerObject * player, PlayerAgent * agent );
	bool goToPoint( Vector2D target_point );

	Vector2D getFastestOppPos();
	Vector2D getMyPos();
	Vector2D getBallPos();

};

#endif //Block
