// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef __GOAL_PLAN_H_
#define __GOAL_PLAN_H_

#include "PreDecidedPassBase.h"

#include <string>

#include <rcsc/geom/segment_2d.h>
#include <rcsc/geom/vector_2d.h>
#include <rcsc/geom/polygon_2d.h>
#include <rcsc/player/player_agent.h>

using namespace std;

class GoalPlan: public PreDecidedPassBase
{
private:

	void changeBallDelay(rcsc::PlayerAgent *agent);

	float addedValues[11];

	float minBallMovement;

	float getPointShootingValue( rcsc::PlayerAgent * agent , rcsc::Vector2D receiverPos );
	float getPointAngleValue( rcsc::Vector2D receivePos );

	float shootingWeight;
	float angleWeight;

public:
	GoalPlan();
	~GoalPlan();

	void addValues( string players , float valueDiff );
	float getValue(rcsc::PlayerAgent *agent);
};

#endif
