// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef __GOAL_PLAN_DRIBBLE_H_
#define __GOAL_PLAN_DRIBBLE_H_

#include <rcsc/geom/vector_2d.h>

#include <rcsc/player/player_agent.h>

enum DribbleDirection
{
	DD_BREAK = 0,
	DD_CLOCK_WISE = 1,
	DD_COUNTER_CLOCK_WISE = 2,
	DD_NONE = 100,
};

enum GoalDribbleSituation
{
	GD_SHOULD = 0,
	GD_CAN = 1,
	GD_SHOULD_NOT = 2,
	GD_CAN_NOT = 3,
};

class GoalPlanDribble
{
private:
	static bool isTargetSet;
	static rcsc::Vector2D currentTarget;
	static DribbleDirection currentDribbleDirection;

	float distanceToChangeTarget;
	void changeTarget( const rcsc::PlayerAgent * agent );

	rcsc::Vector2D dribbleTarget;
public:
	GoalPlanDribble();
	GoalDribbleSituation getValue( rcsc::PlayerAgent * agent );
	void execute( rcsc::PlayerAgent * agent );

	void reset()
	{
		isTargetSet = false;
		currentDribbleDirection = DD_NONE;
	}
};
#endif // __GOAL_PLAN_DRIBBLE_H_
