// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#include <GoalPlanKick.h>

#include <rcsc/common/logger.h>

#include <GoalPlanDribble.h>
#include <GoalPlan.h>

#include <OffenseVariables.h>
#include <PassDecision.h>

using namespace rcsc;

bool GoalPlanKick::execute( rcsc::PlayerAgent * agent )
{
	GoalPlan pass;
	GoalPlanDribble dribble;

	GoalDribbleSituation dribbleValue = dribble.getValue(agent);

	OffenseVariables::Instance()->editLinearPlayers( agent );

	if ( dribbleValue == GD_SHOULD )
	{
		dlog.addText ( Logger::PASS , "BREAKING!!" );
		dribble.execute( agent );
		return true;
	}

	if ( pass.getValue(agent) )
	{
		pass.execute( agent );
		dlog.addText ( Logger::PASS , "GoalPlanSelected!!" );
		return true;
	}

	if ( dribbleValue != GD_CAN_NOT )
	{
		dlog.addText ( Logger::PASS , "NoPass->Dribble" );
		dribble.execute( agent );
		return true;
	}

	PassDecision normalPass(1);
	normalPass.setSafetyFactors(0.9,1.2,0.85,1,3,0.9,2,1,0,8);
	normalPass.setDelayFactors ( 1, 40 , 1, 4.f);
	normalPass.setMaxDirectionCount(3);
	Decision pd = normalPass.getValue(agent,true);
	if ( pd != CAN_NOT_DO_IT )
	{
		normalPass.execute(agent,true,2);
		dlog.addText ( Logger::PASS , "Normal Pass!!" );
		return true;
	}

	{
		dlog.addText ( Logger::PASS , "NoNormalPass->Dribble Forced" );
		dribble.execute( agent );
		return true;
	}
}
