// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef __GOAL_PLAN_POSITIONING_
#define __GOAL_PLAN_POSITIONING_

#include <rcsc/player/player_agent.h>

enum PlayerRole
{
	GPP_BOTTOMOUT = 0,
	GPP_BOTTOMIN = 1,
	GPP_TOPIN = 2,
	GPP_TOPOUT = 3,
	GPP_NONE = 100,
};

class GoalPlanPositioning
{
private:
	float toBeCoveredAreaWidth;
	float middleAreaY;

	PlayerRole getBallOwnerRole ( int ballOwnerUnum );
	PlayerRole getPlayerRole ( int myUnum );
	PlayerRole getSubstituedRole ( PlayerRole realBallRole , PlayerRole fakeBallRole , PlayerRole playerRealRole );

	void setMiddleAreaY ( PlayerRole ballOwnerRole , float ballY );
	float getRoleY( PlayerRole ballOwnerRole , PlayerRole roleChoosed , float ballY );
	float getPlayerX ( int unum );

public:
	GoalPlanPositioning()
	{
		toBeCoveredAreaWidth = 20.f;
		middleAreaY = 0.f;
	}

	rcsc::Vector2D getHomePos( const rcsc::WorldModel * wm );
};

#endif // __GOAL_PLAN_POSITIONING_
