// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef __PRIMARY_GOAL_PLAN_POSITIONING_H_
#define __PRIMARY_GOAL_PLAN_POSITIONING_H_

#include <vector>

#include <rcsc/geom/vector_2d.h>

#include <rcsc/player/world_model.h>

#include <GoalPlanPositioning.h>

class PrimaryGoalPlanPositioning
{
private:
	float toBeCoveredAreaWidth;

	float determiningQuarterWidth;

	PlayerRole getBallCurrentRole( rcsc::Vector2D ballPos );

	rcsc::Vector2D getBestPositioningPoint( const rcsc::WorldModel * wm , std::vector<rcsc::Vector2D> targetPos );
	rcsc::Vector2D getRolePos( PlayerRole ballRole , PlayerRole playerRole , const rcsc::WorldModel * wm);

public:
	PrimaryGoalPlanPositioning()
	{
		toBeCoveredAreaWidth = 20.f;
		determiningQuarterWidth = 10.f;
	}

	rcsc::Vector2D getHomePos( const rcsc::WorldModel * wm );
};

#endif // __PRIMARY_GOAL_PLAN_POSITIONING_H_
