// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#include <BreakerMove.h>

#include <OffenseVariables.h>
#include <FastIC.h>

#include <rcsc/action/body_turn_to_angle.h>
#include <rcsc/action/body_go_to_point.h>
#include <rcsc/action/neck_turn_to_low_conf_teammate.h>

#include <rcsc/common/logger.h>
#include <rcsc/common/audio_memory.h>

using namespace rcsc;

bool BreakerMove::shouldExecute( const rcsc::WorldModel & wm )
{
	dlog.addText ( Logger::PASS , "shire khar!!!" );
	dlog.addText ( Logger::PASS , "isEmpty??\t%d" , wm.audioMemory().helliBreaker().empty() );
	if ( wm.audioMemory().helliBreaker().empty() )
		return false;
	dlog.addText ( Logger::PASS , "receiveTime\t%d", wm.audioMemory().helliBreakerTime().cycle() );
	if ( abs ( wm.time().cycle() - wm.audioMemory().helliBreakerTime().cycle() ) > 3 ) 
		return false;
//	if ( wm.audioMemory().helliBreaker().front().mustReachCycle_ < wm.time().cycle() )
//		return false;
	return true;
}

void BreakerMove::execute( PlayerAgent * agent )
{
	dlog.addText ( Logger::PASS , "executing!!" );
//	FastIC fast;
	const WorldModel & wm = agent->world();
	agent->setNeckAction( new rcsc::Neck_TurnToLowConfTeammate() );
	if ( wm.audioMemory().helliBreaker().empty() )
		return;
//	fast.players().push_back( FastPlayer( wm.self().pos() , wm.self().vel() , 0 , wm.self().unum() , true , 1 , 1 , wm.self().playerType().id()  , NULL , NULL ) );
	Vector2D targetPos = OffenseVariables::Instance()->getRunnerPosition( wm.offsideLineX() , wm.self().pos() );
//	fast.setBall( targetPos , Vector2D(0.f , 0.f) , 0 );
//	fast.calculate( 15 );
//	if ( fast.getFastestPlayers().size() == 0 )
//		return;
//	else
//	{
		Vector2D meToTarget = targetPos - wm.self().pos();
		meToTarget *= 100;
		targetPos = wm.self().pos() + meToTarget;
//		int reachCycle = wm.time().cycle() + fast.getFastestPlayers()[0].reachCycle;
//		int neededReach = wm.audioMemory().helliBreaker().front().mustReachCycle_;
//		dlog.addText ( Logger::PASS , "reachCycle\t%d" , reachCycle );
//		dlog.addText ( Logger::PASS , "neededReach\t%d" , neededReach );
//		if ( reachCycle < neededReach )
//		    Body_TurnToAngle( (targetPos - wm.self().pos() ).th() ).execute( agent );
//		else
			Body_GoToPoint( targetPos , 0.5 , 100 ).execute( agent );
//	}
}
