// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef _DRIBBLE_DECISION_H
#define _DRIBBLE_DECISION_H

#include <body_dribble2008.h>
#include <HelliBASH09SRP.h>
#include <Basics.h>

#include <rcsc/geom/vector_2d.h>
#include <rcsc/geom/polygon_2d.h>
#include <rcsc/player/player_agent.h>

class DribbleDecision
{
private:
	rcsc::Vector2D mTarget;
	bool cSRP;
	HelliBASH09SRP mSRP;
	float riskyDribbleRange;
	int maxPlayersInRectangle;
	float dribbleSpeed;

	rcsc::Vector2D dribble2008_target;
	int dashCount;
	float currentLocalOffsideLine;

	bool shouldWeDribble ( rcsc::PlayerAgent * agent);
	void changeTarget();

	static rcsc::Vector2D currentDribbleTarget;
	void setCurrentOffsideLine( const rcsc::WorldModel & wm );

public:
	DribbleDecision(rcsc::Vector2D myPos);
	DribbleDecision(){}
	~DribbleDecision();
	HelliBASH09SRP & SRPDribble();
	void setRiskyDribbleRange(float f);
	void setMaxPlayersInRectangle(int i);
	Decision getValue(rcsc::PlayerAgent *agent);
	void execute(rcsc::PlayerAgent *agent);
	bool isItOneOnOneCondition ( rcsc::PlayerAgent *agent , rcsc::Vector2D & decidedTarget );
	void doHoldBall ( rcsc::PlayerAgent *agent );
	void reset();
};

#endif // _DRIBBLE_DECISION_H
