// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef _NEW_POSITIONING_H
#define _NEW_POSITIONING_H

#include <string>

#include <rcsc/player/player_agent.h>
#include <rcsc/geom/vector_2d.h>

enum PositionInLine
{
	BOTTOM = 0,
	MIDDLE = 1,
	TOP = 2,
	NONE = 100,
};

enum FakePositionInLine
{
	BOTTOMOUT = 0,
	BOTTOMMIDDLE = 1,
	TOPMIDDLE = 2,
	TOPOUT = 3,
	NONEOUT = 100,
};

enum BallOwnerSideStats
{
	RESTRICTEDMIDDLE = 0,
	RESTRICTEDOPPOSITE = 1,
	USUAL = 2,
	RESET = 100,
};

enum QuarteBackSide
{
	DOWN = 0,
	UP = 1,
};
class NewPositioningSystem
{
private:
	float minRestrictedYForOppositeOwner;
	float minRestrictedYForMiddleOwner;
	float maxAbsoluteYForKeepingLastDecision;

	static FakePositionInLine lastBallFakeSide;

	static BallOwnerSideStats lastBallOwnerSideStats;
	BallOwnerSideStats getBallOwnerSideStats( float posY );

	static QuarteBackSide lastQuarterBackSide;

	PositionInLine getBallOwnerSide( rcsc::Vector2D ballPos , int ballOwner );
	FakePositionInLine getBallFakeSide( rcsc::Vector2D ballPos );
	PositionInLine getDefaultSide( int ballOwner );
	rcsc::Vector2D getSidePosition( PositionInLine ballSide , PositionInLine playerSide , rcsc::Vector2D ballPos , float offsideLine );
	rcsc::Vector2D getSidePosition( FakePositionInLine ballFakeSide , PositionInLine playerSide , rcsc::Vector2D ballPos , float offsideLine , int receiver );
	rcsc::Vector2D getQBPosition( PositionInLine ballSide , rcsc::Vector2D ballPos , float offsideLine );
	rcsc::Vector2D getQBPosition( FakePositionInLine ballFakeSide , rcsc::Vector2D ballPos , float offsideLine );

public:
	NewPositioningSystem();
	rcsc::Vector2D getHomePos( const rcsc::WorldModel * wm );
	static bool getConstantPoint( const rcsc::Vector2D homePos , rcsc::Vector2D & answer );
};

#endif
