// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef _OFFENSE_VARIABLES_H_
#define _OFFENSE_VARIABLES_H_

#include <string>

#include <rcsc/player/world_model.h>
#include <rcsc/player/player_agent.h>

class OffenseVariables
{
private:
	// Positioning Variables
		std::string mLinearPlayers;
		std::string mQuarterBackPlayer;
		float mLaneShift;
		float mBallXAddition;
		float mBottomDist;
		float mBottomOutDist;
		float mTopDist;
		float mTopOutDist;
		float mQuarterBackDist;
		float mOffsideLineWeight;
		float mBallXWeight;

	// GridView Positioning
		int mGridXCount;
		int mGridYCount;

	static int lastDeclarationCycle;

public:
	OffenseVariables();
	~OffenseVariables(){}
	void reset();

	static OffenseVariables * Instance()
	{
		static OffenseVariables* inst = NULL;
		if ( inst == NULL )
			inst = new OffenseVariables();
		return inst;
	}

	void editLinearPlayers( rcsc::PlayerAgent * agent );
	void updateBySay( const rcsc::WorldModel & wm );
	void sayLinearPlayers( rcsc::PlayerAgent* agent );
	rcsc::Vector2D getRunnerPosition( float offsideLine , rcsc::Vector2D runnerPos );

	void changeVariablesIfNeeded( rcsc::Vector2D ballPos );

	std::string & linearPlayers()
	{
		return mLinearPlayers;
	}

	std::string & quarterBackPlayer()
	{
		return mQuarterBackPlayer;
	}

	float & laneShift()
	{
		return mLaneShift;
	}

	float & ballXAddition()
	{
		return mBallXAddition;
	}

	float & bottomDist()
	{
		return mBottomDist;
	}

	float & bottomOutDist()
	{
		return mBottomOutDist;
	}

	float & topDist()
	{
		return mTopDist;
	}

	float & topOutDist()
	{
		return mTopOutDist;
	}

	float & quarterBackDist()
	{
		return mQuarterBackDist;
	}

	float & ballXWeight()
	{
		return mBallXWeight;
	}

	float & offsideLineWeight()
	{
		return mOffsideLineWeight;
	}

	int & gridXCount()
	{
		return mGridXCount;
	}

	int & gridYCount()
	{
		return mGridYCount;
	}

};

#endif // _OFFENSE_VARIABLES_H_
