// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <strategy.h>

#include <OffensiveKick.h>

#include "body_kick_to_corner.h"
#include "body_dribble2008.h"
#include "body_hold_ball2008.h"

#include <rcsc/action/body_advance_ball.h>
#include <rcsc/action/body_kick_multi_step.h>
#include <rcsc/action/body_kick_one_step.h>
#include <rcsc/action/body_dribble.h>
#include <rcsc/action/body_hold_ball.h>
#include <rcsc/action/body_pass.h>
#include <rcsc/action/neck_scan_field.h>
#include <rcsc/action/neck_turn_to_low_conf_teammate.h>
#include <rcsc/action/body_kick_multi_step.h>
#include <rcsc/action/intention_kick.h>

#include <rcsc/player/player_agent.h>
#include <rcsc/player/debug_client.h>

#include <rcsc/common/logger.h>
#include <rcsc/common/server_param.h>
#include <rcsc/geom/sector_2d.h>
#include <rcsc/geom/vector_2d.h>

#include <iostream>

#include "HelliBASH09Pass.h"
#include "HelliBASH09SRP.h"
#include "DribbleDecision.h"
#include "DefenceBreaker.h"
#include "Config.h"
#include "PassConfig.h"
#include "PassDecision.h"
#include "PositioningConfig.h"
//#include "bhv_self_pass.h"
#include <PreDecidedPass.h>
#include <PreDecidedBreaker.h>
#include <FastIC.h>
#include <GoalPlan.h>
#include <GoalPlanDribble.h>
#include <GoalPlanKick.h>
#include <NewPositioningSystem.h>
#include <OffenseVariables.h>

#include <rcsc/player/say_message_builder.h>


using namespace std;
using namespace rcsc;

bool OffensiveKick::execute( rcsc::PlayerAgent * agent )
{
	dlog.addText( rcsc::Logger::PASS,	"%s:%d: OffensiveKick",__FILE__, __LINE__ );
	dlog.flush();

	const WorldModel & wm = agent->world();
	float oppDelayDist = 4.0;

	PreDecidedBreaker pdb( true );
	pdb.setMaxDirectionCount(3);
	DribbleDecision dribble(wm.self().pos());

	OffenseVariables::Instance()->editLinearPlayers( agent );

	PassDecision pass(1);
	pass.setSafetyFactors(0.9,1.2,0.85,1,3,0.9,2,1,0,8);
	pass.setDelayFactors ( 1, 40 , 1, oppDelayDist);
	pass.setMaxDirectionCount(3);

	if ( wm.self().pos().x > 36.f )
	{
		return GoalPlanKick().execute( agent );
	}

	Decision dd = dribble.getValue(agent);
	
	if ( dd == SHOULD_DO_IT )
	{
//		cerr << "Dribble!1On1!" << endl;
		rcsc::dlog.addText ( rcsc::Logger::PASS , "Dribble!1ON1!");dlog.flush();
		dribble.execute(agent);
//		agent->setNeckAction( new rcsc::Neck_TurnToLowConfTeammate() );
		return true;
	}

	if ( pdb.getValue(agent) )
	{
		dlog.addText ( Logger::PASS , "Course Selected" );
		pdb.execute(agent);
		return true;
	}

	GoalPlan goalPlan;
	goalPlan.addValues( "69AB" , 1 );
	if ( goalPlan.getValue( agent ) )
	{
		dlog.addText ( Logger::PASS , "GoalPlan Selected" );
		goalPlan.execute(agent);
		return true;
	}

	Decision pd = pass.getValue(agent,true);

	if ( pd == SHOULD_DO_IT )
	{
//		cerr << "PASS!!!First!!!" << endl;
		rcsc::dlog.addText ( rcsc::Logger::PASS , "First Touch PASS!!");
		pass.execute(agent);
//		agent->setNeckAction( new rcsc::Neck_ScanField() );
		return true;
	}
	if ( dd == CAN_DO_IT )
	{
		rcsc::dlog.addText ( rcsc::Logger::PASS , "Dribbling!!");
		dribble.execute(agent);
//		agent->setNeckAction( new rcsc::Neck_TurnToLowConfTeammate() );
		return true;
	}
	if ( pd == CAN_DO_IT )
	{
//		cerr << "PASS!!!!!!!!!!!" << endl;
		rcsc::dlog.addText ( rcsc::Logger::PASS , "PASS!!");
		pass.execute(agent,true,2);
//		agent->setNeckAction( new rcsc::Neck_ScanField() );
		return true;
	}
	if ( dd == SHOULD_NOT_DO_IT )
	{
		rcsc::dlog.addText ( rcsc::Logger::PASS , "Dribbling!!");
		dribble.execute(agent);
//		agent->setNeckAction( new rcsc::Neck_TurnToLowConfTeammate() );
		return true;
	}
	if ( pd == SHOULD_NOT_DO_IT )
	{
//		cerr << "PASS!!!!!!!!!!!" << endl;
		rcsc::dlog.addText ( rcsc::Logger::PASS , "FORCED PASS!!");
		pass.execute(agent,true,2);
//		agent->setNeckAction( new rcsc::Neck_ScanField() );
		return true;
	}			
	if ( dd == CAN_NOT_DO_IT )
	{
		rcsc::dlog.addText ( rcsc::Logger::PASS , "ControlBALL!!!Bull shit");
		dribble.doHoldBall(agent);
//		agent->setNeckAction( new rcsc::Neck_TurnToLowConfTeammate() );
		return true;
	}
	dlog.addText ( Logger::PASS , "We Gotta Dribble");
	dribble.execute(agent);
//	agent->setNeckAction( new rcsc::Neck_TurnToLowConfTeammate() );
	return true;
}
