// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef _PASS_DECISION_H_
#define _PASS_DECISION_H_

#include <HelliBASH09Pass.h>
#include <PassConfig.h>
#include <Basics.h>
#include <PreDecidedPass.h>

#include <rcsc/geom/vector_2d.h>
#include <rcsc/geom/polygon_2d.h>
#include <rcsc/player/player_agent.h>

#include <vector>

class PassDecision
{
private:
	static int passStyle;
	static std::vector<PassConfig> passConfs;
	HelliBASH09Pass mPass;
	PreDecidedPass prePass;
	bool mustEstimateHalfs;
	
	// Safety Factors
	float oppKickable;
	float oppCatchable;
	float oppMaxDash;
	int oppMaxPosCount;
	float tmmKickable;
	float tmmCatchable;
	float tmmMaxDash;
	int tmmMaxPosCount;
	int maxDirectionCount;

		// Delay Factors
		float oppMaxDistanceDelay;
		int oppDelay;
		float tmmMaxDistanceDelay;
		int tmmDelay;

public:
	PassDecision(int style);
	~PassDecision();
	void setSafetyFactors(float _tmmKickable,float _tmmCatchable,float _tmmMaxDash,int _tmmDelay,int _tmmMaxPosCount,float _oppKickable,float _oppCatchable,float _oppMaxDash,int _oppDelay,int _oppMaxPosCount);
	void setDelayFactors( int _tmmDelay , float _tmmMaxDistanceDelay , int _oppDelay , float _oppMaxDistanceDelay);
	Decision getValue(rcsc::PlayerAgent *agent, bool estimateHalfs = false);
	void execute(rcsc::PlayerAgent *agent,bool isEnforced = false ,int kickSteps = 3);
	void setMaxDirectionCount(int f);
};

#endif
