// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#include <PenaltyAreaPositioning.h>
#include <Share.h>

#include <rcsc/common/logger.h>

#include <rcsc/player/intercept_table.h>
#include <rcsc/common/server_param.h>

#include <Basics.h>

using namespace rcsc;
using namespace std;
using namespace Basics;

PenaltyAreaPositioning::PenaltyAreaPositioning( const WorldModel *wm, string offensePlayers )
{
	players = offensePlayers;
	detectReceiveInfo(wm);

	myunum = wm->self().unum();
	lineX = min( wm->offsideLineX() - 2, wm->ball().pos().x + 1 );
	minY = -18;
	maxY = 18;
	if(wm->ball().pos().y > 0)
		minY += 5;
	else
		maxY -= 5;
}

Vector2D PenaltyAreaPositioning::getHomePos()
{
	dlog.addText( Logger::ROLE, "hava mikone!!");
	unsigned NUM[4], j = 0;

	for(int i = 0; i < 4; i++)
	{
		unsigned test;
		char c = players[i];
		if (c == 'A')
		    test = 10;
		else
		if (c == 'B')
		    test = 11;
		else
		    test = c - 48;
		if ( test != receiver )
		{
			NUM[j] = test;
			j++;
		}
	}

	unsigned back, back2;
	float gcc = (maxY - minY) / 3;
	unsigned t, k;
	if( not isInPlayers(receiver, players) )
		t = 0, k = 4, back = 1, back2 = 2;
	else
	{
		if( receivePos.y > 0 )
			t = 0, back = 1, back2 = 2;
		else
			t = 1, back = 2, back2 = 1;
		k = 3;
	}
	for(uint i = t; i < t + k; i++)
	{
		Vector2D thisPoints;
		float y = minY + (i * gcc),
			  x = lineX;
		dlog.addText( Logger::ROLE, "hanuz hava nakarde!!!");
		if( i == back2 )
		{
			dlog.addText( Logger::ROLE, "i == back2 ");
			x = 36;
		}
		else if( i == back )
		{
			dlog.addText( Logger::ROLE, "i == back ");
			x = max(41.f, lineX - 10);
		}
		dlog.addText( Logger::ROLE, "hava kard!!!" );
		thisPoints = Vector2D(x, y);
		if( thisPoints.dist(receivePos) < 5 )
			thisPoints = Vector2D(x - 3, y);
		Points.push_back(thisPoints);

	}

//	unsigned j = 0;
	for(uint i = 0; i < j; i++)
	{
//		if( isForReceiverPlayer(i) )
//			continue;
/*		if( NUM[i] == receiver )
		{
			j++;
			continue;
		}
*/		if ( NUM[i] == myunum )
			return Points[i];
//		j++;
	}
	dlog.addText( Logger::ROLE, "Khak to saram shod!!!" );
}

bool PenaltyAreaPositioning::isForReceiverPlayer(unsigned pos)
{
	if( not isInPlayers(receiver, players) )
		return false;

	unsigned j = 0;
	float dist = 100;

	for(uint i = 0; i < players.size(); i++)
	{
		if( receivePos.dist(Points[i]) < dist )
		{
			dist = receivePos.dist(Points[i]);
			j = i;
		}
	}

	if( pos == j )
		return true;
	return false;
}

void PenaltyAreaPositioning::detectReceiveInfo(const WorldModel *wm)
{
	if (wm->interceptTable()->teammateReachCycle() < 8)
	{
		receivePos = getBallPosAfterCycles(wm->ball(),wm->interceptTable()->teammateReachCycle(),rcsc::ServerParam::i().ballDecay());
		receiver = wm->interceptTable()->fastestTeammate() ? wm->interceptTable()->fastestTeammate()->unum() : 0;
		if (!isInField(receivePos))
		{
			receivePos = wm->ball().pos();
			receiver = 0;
		}
		return;
	}
	receivePos = wm->ball().pos();
	receiver = 0;
}
