// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef __PRE_DECIDED_BREAKER_H_
#define __PRE_DECIDED_BREAKER_H_

#include <PreDecidedPassBase.h>

#include <string>

#include <rcsc/geom/vector_2d.h>
#include <rcsc/geom/polygon_2d.h>
#include <rcsc/player/player_agent.h>

struct BreakerResult // player solo receive
{
	float value;
	PreDecidedPassRelease releaseStats;
};

class PreDecidedBreaker: public PreDecidedPassBase
{
private:
	int maxRunCycles;
	int maxPossibleRunCycles;
	std::string defenceBreakers;
	rcsc::Polygon2D behindEnemyLines;
	float targetLineX;
	float maxDistanceToTargetLine;
	float maxDistanceForCallingRun;
	float maxReceiverYChange;
	float minBallMovement;

	void setBehindEnemyLines(const rcsc::WorldModel & wm , float countingRadius);
	void setMaxRunCycles(rcsc::PlayerAgent *agent);

	std::vector< rcsc::Vector2D > opponentLine;
	float getTargetX(float lineY);

	BreakerResult getThisPlayerValue( const rcsc::PlayerAgent *agent , PreDecidedPassPlayer receiver );
	int getMaxDelay( PreDecidedPassPlayer receiver , bool tillTargetLine = true);
	void advantagePlayer( unsigned int tmmBlock , bool changePos = false , bool zeroDelay = false);
	void disadvantageDefendingLine(float countingRadius , int myUniNum);
	void disadvantageNearDefences(float countingRadius , rcsc::Vector2D ballPos );
	void makeStaticDefendingLine(float countingRadius , int myUniNum);
	void setPlayers(const rcsc::WorldModel & wm);
	int getFastestOppReachCycle(const rcsc::WorldModel & wm);

	bool shouldCallRun;

	static int sumCount , numCount;
	static float dirCount , rateCount;
	static int countSetCycle;
public:
	PreDecidedBreaker( bool b = true );
	~PreDecidedBreaker();
	
	float getValue(rcsc::PlayerAgent *agent);

	void setBreakers(std::string breakers)
	{
		defenceBreakers = breakers;
	}

	void setMaxDistanceToTargetLine(float max)
	{
		maxDistanceToTargetLine = max;
	}
};

#endif //__PRE_DECIDED_BREAKER_H_
