// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef __PRE_DECIDED_PASS_H_
#define __PRE_DECIDED_PASS_H_

#include "PreDecidedPassBase.h"

#include <string>

#include <rcsc/geom/vector_2d.h>
#include <rcsc/geom/polygon_2d.h>
#include <rcsc/player/player_agent.h>


class PreDecidedPass: public PreDecidedPassBase
{
private:
	// Factors
	bool insidePolygonPass;
	rcsc::Polygon2D mTargetPolygon;

	int distToGoalWeight;
	bool checkDistToGoal;
	float maxDistanceToGoal;

	int forwardMovementWeight;
	bool checkForwardMovement;
	float maxForwardMovement;
	
	int receiverMovementWeight;
	bool checkReceiverMovement;
	float maxReceiverMovement;
	
	int receiverAbilityWeight;
	bool checkReceiverAbility;
	int maxOpponents;
	float countingRadius;

	float minBallMovement;
	float maxDistanceForStraightPass;
	float minReceiverDist;
	
	int maxHoldBallCycles;

	bool isOpen[11];

	static int sumCount , numCount;

	static float dirCount , rateCount;
	static int countSetCycle;
public:
	PreDecidedPass();
	~PreDecidedPass();

	rcsc::Polygon2D & targetPolygon();
	void setInsidePolygonPass(bool b);
	void setDistToGoalParameters(int weight = 1,float maxDist = 110.f , bool checkIt = true);
	void setForwardMovementParameters(int weight = 1,float maxMove = 105 , bool checkIt = true);
	void setReceiverMovementParameters(int weight = 1,float maxMove = 110 , bool checkIt = true);
	void setReceiverAbilityParameters(int weight = 1,int max = 11 , bool checkIt = true);	

	void setOpenPlayers(std::string players);
	void changeBallDelay(rcsc::PlayerAgent *agent);

	float getValue(rcsc::PlayerAgent *agent);

	void setMaxDistanceForStraightPass( float max )
	{
		maxDistanceForStraightPass = max;
	}
};

#endif
