// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#include <VirtualPassBase.h>

using namespace std;
using namespace rcsc;
VirtualPassBase::VirtualPassBase() : fastIC()
{
	tmmDelay = 2;
	tmmControlBuff = 0.9;
	tmmMaxDash = 0.85;
	oppDelay = 1;
	oppControlBuff = 0.9;
	oppMaxDash = 1;

	maxTmmPosCount = 3;
	maxOppPosCount = 20;

	startAngle = -180;
	endAngle = 180;
	startRate = 0.5;
	endRate = 3.f;

	maxDirectionCount = 5;

	checkHalfs = true;

	mBall.delay = 2;
	mBall.mPos = Vector2D ( -100 , 100 );
	
	setThisCycle = false;

	for (map<float, map<float, bool> >::iterator it = isChecked.begin();
		it != isChecked.end(); it++)
	{
		for (map<float, bool>::iterator jit = it->second.begin(); jit != it->second.end(); jit++)
		{
			jit->second = false;
		}
	}
}

VirtualPassBase::~VirtualPassBase()
{
}

void VirtualPassBase::reset()
{
	for (map<float, map<float, bool> >::iterator it = isChecked.begin();
		it != isChecked.end(); it++)
	{
		for (map<float, bool>::iterator jit = it->second.begin(); jit != it->second.end(); jit++)
		{
			jit->second = false;
		}
	}
}

void VirtualPassBase::deleteMemory()
{
	for (map<float, map<float, bool> >::iterator it = isChecked.begin();
		it != isChecked.end(); it++)
	{
		for (map<float, bool>::iterator jit = it->second.begin(); jit != it->second.end(); jit++)
		{
			jit->second = false;
		}
	}
}
