// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#include <DefenseBack.h>

#include <DefenseKickAction.h>
#include <OffensiveKick.h>

#include <body_go_to_point2008.h>

#include <sstream>
#include <cmath>
#include <vector>
#include <Basics.h>
#include <Share.h>
#include <FastIC.h>

#include <rcsc/action/body_turn_to_point.h>
#include <rcsc/action/body_turn_to_angle.h>
#include <rcsc/action/neck_turn_to_ball_or_scan.h>
#include <rcsc/action/neck_turn_to_point.h>
#include <rcsc/action/neck_turn_to_relative.h>
#include <rcsc/action/view_wide.h>
#include <rcsc/action/view_normal.h>

#include <rcsc/player/player_agent.h>
#include <rcsc/player/audio_sensor.h>
#include <rcsc/player/say_message_builder.h>
#include <rcsc/common/logger.h>
#include <rcsc/common/basic_client.h>

#include <rcsc/player/intercept_table.h>

#include <Intercept.h>
#include <body_clear_ball2008.h>

#include <SayMarkTable.h>
#include <BackDefenderGuard.h>

#include <rcsc/math_util.h>

#include <DangerAreaClear.h>
#include <BlockIntercept.h>
#include <Tackle.h>

using namespace Basics;
using namespace rcsc;
using namespace std;

bool DefenseBack::isLastActionScanning = false;

void DefenseBack::execute(rcsc::PlayerAgent * agent)
{
	dlog.addText(Logger::ROLE, "Entering DefenseBack::execute -----");dlog.flush();
	wm = &agent->world();
	bool isOffsideTrapSituation = false;
	if (wm->ball().pos().x > -31.0 /*and wm->ball().pos().x > markTarget->pos().x + 25.0*/)
	{
		homePos.x = max(homePos.x, -36.0);
		isOffsideTrapSituation = true;
		dlog.addText(Logger::MARK, "OFFSIDE TRAP !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
	}


	for (uint i = 0 ; i < wm->opponentsFromSelf().size() ; i++)
		dlog.addText(Logger::ROLE, "%d (%f, %f) %d %d", wm->opponentsFromSelf()[i]->unum(),
			wm->opponentsFromSelf()[i]->pos().x, wm->opponentsFromSelf()[i]->pos().y, wm->opponentsFromSelf()[i]->posCount()
			, wm->opponentsFromSelf()[i]->posValid());

        agent->setNeckAction( new Neck_TurnToBallOrScan() );

	Share::isScanning = false;

	// Saying markTargets
	if (SayMarkTable().execute(agent))
		dlog.addText(Logger::ROLE, "Mark message said successfuly");
	else
	// Saying Positions
	{
		static map<int, int> oppLastSay;
		static map<int, int> tmmLastSay;
		static bool firstTime = true;
		if (firstTime)
			for (int i = 1 ; i <= 11 ; i++)
			{
				oppLastSay[i] = 100;
				tmmLastSay[i] = 100;
			}
		firstTime = false;
		for (int i = 1 ; i <= 11 ; i++)
		{
			oppLastSay[i]++;
			tmmLastSay[i]++;
		}


		vector<PlayerObject*> dangOppPlayers;
		vector<PlayerObject*> oppPlayers;

		vector<PlayerObject*> tmmPlayers;
		vector<PlayerObject*> players;

		// recognizing the good dangerous opp players for say
		if (Share::markSayMsg != "M000000000")
		{
			for (uint i = 1 ; i < Share::markSayMsg.size() ; i++)
				if (Share::markSayMsg[i] != '0')
				{
					int oppUnum = 0;
					if (Share::markSayMsg[i] == 'A')
						oppUnum = 10;
					else if (Share::markSayMsg[i] == 'B')
						oppUnum = 11;
					else
						oppUnum = Share::markSayMsg[i] - '0';

					for (uint j = 0 ; j < wm->opponentsFromSelf().size() ; j++)
						if (wm->opponentsFromSelf()[j]->unum() == oppUnum and wm->opponentsFromSelf()[j]->posCount() == 0)
						{
							dangOppPlayers.push_back( wm->opponentsFromSelf()[j] );
							break;
						}

				}
		}

		for (uint i = 0 ; i < dangOppPlayers.size() ; i++)
			for (uint j = 0 ; j < dangOppPlayers.size() - 1 ; j++)
				if (oppLastSay[dangOppPlayers[j]->unum()] < oppLastSay[dangOppPlayers[j + 1]->unum()])
				{
					PlayerObject* temp = dangOppPlayers[j];
					dangOppPlayers[j] = dangOppPlayers[j + 1];
					dangOppPlayers[j + 1] = temp;
				}
		// -----------------------------------------

		// recognizing the good opp players for say
		for (uint i = 0 ; i < wm->opponentsFromSelf().size() ; i++)
			if (!isInPlayers(wm->opponentsFromSelf()[i]->unum(), Share::markSayMsg) and wm->opponentsFromSelf()[i]->posCount() == 0)
			{
				oppPlayers.push_back( wm->opponentsFromSelf()[i] );
			}

		for (uint i = 0 ; i < oppPlayers.size() ; i++)
			for (uint j = 0 ; j < oppPlayers.size() - 1 ; j++)
				if (oppLastSay[oppPlayers[j]->unum()] < oppLastSay[oppPlayers[j + 1]->unum()])
				{
					PlayerObject* temp = oppPlayers[j];
					oppPlayers[j] = oppPlayers[j + 1];
					oppPlayers[j + 1] = temp;
				}
		// -----------------------------------------

		// recognizing the good tmm players for say
		for (uint i = 0 ; i < wm->teammatesFromSelf().size() ; i++)
			if (wm->teammatesFromSelf()[i]->posCount() == 0)
				tmmPlayers.push_back(wm->teammatesFromSelf()[i]);

		for (uint i = 0 ; i < tmmPlayers.size() ; i++)
			for (uint j = 0 ; j < tmmPlayers.size() - 1 ; j++)
				if (tmmLastSay[tmmPlayers[j]->unum()] < tmmLastSay[tmmPlayers[j + 1]->unum()])
				{
					PlayerObject* temp = tmmPlayers[j];
					tmmPlayers[j] = tmmPlayers[j + 1];
					tmmPlayers[j + 1] = temp;
				}
		// ----------------------------------------

		for (uint i = 0 ; i < dangOppPlayers.size() ; i++)
			players.push_back(dangOppPlayers[i]);

		for (uint i = 0 ; i < oppPlayers.size() ; i++)
			players.push_back(oppPlayers[i]);

		for (uint i = 0 ; i < tmmPlayers.size() ; i++)
			players.push_back(tmmPlayers[i]);


		vector<WindowPlayerToSend> lastPlayers;
		// -----> 0
		for (uint i = 0 ; i < min(players.size(), (unsigned)4) ; i++)
		{
			if (players[i]->side() == wm->ourSide())
				tmmLastSay[players[i]->unum()] = 0;
			else
				oppLastSay[players[i]->unum()] = 0;

			lastPlayers.push_back( WindowPlayerToSend(players[i]->unum(), players[i]->side() == wm->ourSide(), players[i]->pos()) );
		}
		// --------

		if (wm->time().cycle() - Share::markSayCycle < 5)
		{
			dlog.addText(Logger::ROLE, "No mark message said(?)");
			dlog.addText(Logger::ROLE, "After mark say REPEAT say");
			agent->M_client->sendMessage(("(say " + Share::markSayMsg + ")").c_str());
			dlog.addText(Logger::ROLE, "Repeat say: %s", ("(say " + Share::markSayMsg + ")").c_str());
		}
		if (lastPlayers.size() > 0)
		{
			for (uint i = lastPlayers.size() ; i < 4 ; i++)
				lastPlayers.push_back( WindowPlayerToSend(0, false, Vector2D(0, 0), false) );

			agent->addSayMessage( new FourPlayerMessage(lastPlayers[0], lastPlayers[1], lastPlayers[2], lastPlayers[3]) );

			dlog.addText(Logger::ROLE, "BACK DEFENDER POSITION SAY");
			dlog.addText(Logger::ROLE, "dng %d", dangOppPlayers.size());
			dlog.addText(Logger::ROLE, "opp %d", oppPlayers.size());
			dlog.addText(Logger::ROLE, "tmm %d", tmmPlayers.size());
			dlog.addText(Logger::ROLE, "all %d", players.size());
			dlog.addText(Logger::ROLE, "--------------------");
			for (uint i = 0 ; i < lastPlayers.size() ; i++)
				dlog.addText(Logger::ROLE, "--> %d (%.2f, %.2f)", lastPlayers[i].uniNum, lastPlayers[i].pos.x, lastPlayers[i].pos.y);
			dlog.addText(Logger::ROLE, "--------------------");
		}
		else
		// Repeat mark say
		{
			dlog.addText(Logger::ROLE, "No mark message said(?)");
			dlog.addText(Logger::ROLE, "without positiong say --> REPEAT SAY");
			agent->M_client->sendMessage(("(say " + Share::markSayMsg + ")").c_str());
			dlog.addText(Logger::ROLE, "Repeat say: %s", ("(say " + Share::markSayMsg + ")").c_str());
		}
	}
	dlog.flush();

	// Kick decision
	bool kickable = wm->self().isKickable();

	if (wm->existKickableTeammate())
	{
		if (wm->teammatesFromBall().front()->distFromBall() < wm->ball().distFromSelf() - 0.5)
			kickable = false;
		if (wm->teammatesFromBall().front()->unum() < wm->self().unum())
			kickable = false;
	}

	if (kickable)
	{
		doKick(agent);
		isLastActionScanning = false;
		return;
	}
	// -----------------------


	dlog.addText(Logger::ROLE, "INTERCEPT SITUATION:\t%d", Basics::isInterceptSituation(agent));

	// Tackle
	if (Tackle().execute(agent))
	{
		dlog.addText(Logger::ROLE, "Tackle executed !!!");
		isLastActionScanning = false;
		return;
	}

	dlog.addText(Logger::ROLE, "isSelfFastest: %d", FastIC::isSelfFastestPlayer());
	dlog.addText(Logger::ROLE, "isCelfFastest: %d", wm->interceptTable()->isSelfFastestPlayer());

	// Interception
	if
	(
		FastIC::isSelfFastestPlayer()
	)
	{
		Share::checkInterceptSituation = true;
		agent->setNeckAction(new Neck_TurnToBallOrScan() );
		Intercept().execute(agent);
		dlog.addText(Logger::ROLE, "Defense Interception !!!");
		isLastActionScanning = false;
		return;
	}

	rcsc::PlayerObject* fastestDef = fastestDefender(agent, "23456789AB");

	Vector2D reachPoint = getFastestReachPoint(wm);
	dlog.addText(Logger::ROLE, "fastest reach point : (%f, %f)", reachPoint.x, reachPoint.y);

	const PlayerObject* fastestOpp = (const PlayerObject*)FastIC::getFastestOpponent();

	if (fastestOpp)
	{
		dlog.addText(Logger::ROLE, "Fastest Opp: %d", fastestOpp->unum());
		dlog.addText(Logger::ROLE, "fastest Opp pos: (%f, %f)", fastestOpp->pos().x, fastestOpp->pos().y);
	}

	dlog.addText(Logger::ROLE, "is our team ball possessor: %d", FastIC::isOurTeamBallPossessor());


	dlog.addText(Logger::ROLE, "condition IIIIIIIIIIII: %d", (fastestDef and
		fastestDef->pos().x > wm->ball().pos().x - 2 and
		wm->ball().pos().x < -10.0 and
		wm->ball().pos().absY() < 15.0 and
		wm->self().pos().x < wm->ball().pos().x + 5.0 and
		!FastIC::isOurTeamBallPossessor()));

	// Block
	if
	(
		(
		fastestDef->isSelf()/*amIFastestDefender(agent, "23456789AB", "1")*/ or 

		( fastestDef and
		fastestDef->pos().x > wm->ball().pos().x - 2 and
		wm->ball().pos().x < -10.0 and
		wm->ball().pos().absY() < 15.0 and
		wm->self().pos().x < wm->ball().pos().x + 5.0 and
		!FastIC::isOurTeamBallPossessor() and
		(wm->ball().pos().x < -26.25 or Basics::defenseLineX(wm) > -26.25) ) or

		(fastestOpp and
		fastestOpp->pos().x < -32.0 and
		!isInPlayers(fastestOpp->unum(), Share::markSayMsg) and
		!FastIC::isOurTeamBallPossessor()) or

		(fastestOpp and fastestOpp->pos().x < -40.0 and fastestOpp->pos().absY() < 9.0)
		)
		and
		(wm->self().pos().dist(reachPoint) < 10.0 or wm->self().pos().dist(homePos) < 5.0 or reachPoint.absY() < 17.0)

	)
	{
		Share::checkInterceptSituation = true;

		if (Block().execute(agent))
			dlog.addText(Logger::ROLE, "Defense Blocking");
		else
		{
			Intercept().execute(agent);
			dlog.addText(Logger::ROLE, "Block false value: intercepting");
		}

		isLastActionScanning = false;
		return;
	}

	// Mark
	if (wm->ball().pos().x < -32.0 and wm->self().pos().x < -36.0)
	{
		Vector2D topLeft(-53.0, wm->ball().pos().y > 0.0 ? -7.0 : -18.0);
		Rect2D markArea( topLeft, topLeft + Vector2D(16.0, 25.0) );

		PlayerObject* bestOpp = NULL;
		for (int i = 1 ; i < 7 ; i++)
		{
			PlayerObject* tmm = NULL;
			for (uint j = 0 ; j < wm->teammatesFromSelf().size() ; j++)
				if (wm->teammatesFromSelf()[j]->unum() == i + 2)
					tmm = wm->teammatesFromSelf()[j];

			int oppUnum = 0;
			if (Share::markSayMsg[i] == 'A')
				oppUnum = 10;
			else if (Share::markSayMsg[i] == 'B')
				oppUnum = 11;
			else
				oppUnum = Share::markSayMsg[i] - '0';

			PlayerObject* opp = NULL;
			for (uint j = 0 ; j < wm->opponentsFromSelf().size() ; j++)
				if (wm->opponentsFromSelf()[j]->unum() == oppUnum)
					opp = wm->opponentsFromSelf()[j];

			if
			(
			opp and markArea.contains(opp->pos()) and ( (opp->posCount() < 4 and !tmm) or (tmm and tmm->pos().x > opp->pos().x + 1.5) )
			)
			{
				if ( !bestOpp or opp->pos().dist(wm->ball().pos()) < bestOpp->pos().dist(wm->ball().pos()) )
					bestOpp = opp;
			}
		}

		if (bestOpp)
		{
			Vector2D markPoint = bestOpp->pos() + Vector2D(-1.0, 0.0);
			markPoint.x = min(-42.0, markPoint.x);

			if (Body_GoToPoint2008(markPoint, 1.0, 100).execute(agent))
				dlog.addText(Logger::ROLE, "Back Defender MARK go_to_point --> opp: %d", bestOpp->unum());
			else
			{
				Body_TurnToPoint(wm->self().pos() + Vector2D(-1.0, 0.0)).execute(agent);
				dlog.addText(Logger::ROLE, "Back defender MARK turn_to_point --> opp: %d", bestOpp->unum());
			}

			return;
		}
	}

	// Mark 2

		PlayerObject* bestOpp = NULL;
		for (uint i = 0 ; i < wm->opponentsFromSelf().size() ; i++)
		{
			if (isInPlayers(wm->opponentsFromSelf()[i]->unum(), Share::markSayMsg))
			{
			
			
				for (uint j = 0 ; j < Share::markSayMsg.size() ; j++)
				{
					int oppUnum = 0;
					if (Share::markSayMsg[j] == 'A')
						oppUnum = 10;
					else if (Share::markSayMsg[j] == 'B')
						oppUnum = 11;
					else
						oppUnum = Share::markSayMsg[j] - '0';

					if (oppUnum == wm->opponentsFromSelf()[i]->unum())
					{
						for (uint k = 0 ; k < wm->teammatesFromSelf().size() ; k++)
							if (wm->teammatesFromSelf()[k]->unum() == Share::markSayMsg[j]
								and (wm->teammatesFromSelf()[k]->pos().x > wm->opponentsFromSelf()[i]->pos().x + 2.5
									or fabs(wm->teammatesFromSelf()[k]->pos().y - wm->opponentsFromSelf()[i]->pos().y) > 10.0)
							)
							{
								if (!bestOpp or wm->opponentsFromSelf()[i]->pos().x < bestOpp->pos().x)
									bestOpp = wm->opponentsFromSelf()[i];
							}
					}
					
				}
			
			
			}
			else if (!bestOpp or wm->opponentsFromSelf()[i]->pos().x < bestOpp->pos().x)
				bestOpp = wm->opponentsFromSelf()[i];
		}

		if (bestOpp and bestOpp->pos().x < -10.0 and bestOpp->pos().x < homePos.x + 15.0 and bestOpp->pos().absY() < 10.0)
		{
			Vector2D markPoint = bestOpp->pos() + Vector2D(-3.0, 0.0);

			if (Body_GoToPoint2008(markPoint, 1.0, 100).execute(agent))
				dlog.addText(Logger::ROLE, "Back Defender MARK go_to_point --> opp: %d", bestOpp->unum());
			else
			{
				Body_TurnToPoint(wm->self().pos() + Vector2D(-1.0, 0.0)).execute(agent);
				dlog.addText(Logger::ROLE, "Back defender MARK turn_to_point --> opp: %d", bestOpp->unum());
			}

			return;
		}

	// Guard
	if (BackDefenderGuard().execute(agent))
	{
		dlog.addText(Logger::ROLE, "DefenseBack Guard");
		isLastActionScanning = false;
		return;
	}

	// Going back when defense passed
	if (wm->ball().pos().x < wm->self().pos().x and
		wm->self().pos().x > -36.0 and
		!wm->interceptTable()->isOurTeamBallPossessor() and
		!Share::defensePassed)
	{
		Share::defensePassed = true;
		Share::returnY = min_max(-5.0, wm->self().pos().y, +5.0);
	}

	if (wm->ball().pos().x > wm->self().pos().x + 5.0 or
		wm->self().pos().x < -43.0 or
		wm->interceptTable()->isOurTeamBallPossessor() or
		wm->gameMode().type() != GameMode::PlayOn)
		Share::defensePassed = false;

	if (Share::defensePassed)
	{
		dlog.addText(Logger::ROLE, "Zooood bargard aghab <<<===---");

		Body_GoToPoint2008(Vector2D(-47.0, Share::returnY), 5.0, 100).execute(agent);
		agent->setNeckAction(new Neck_TurnToBallOrScan());
		isLastActionScanning = false;
		return;
	}


	// Scanning
	if ( wm->ball().pos().x - wm->self().pos().x > 20.0 and
		wm->self().pos().dist(homePos) < 5.0 )
	{
//		agent->setViewAction( new View_Wide() );
//		agent->setNeckAction( new Neck_TurnToPoint(wm->self().pos() + Vector2D(1, 0)) );

		if (isLastActionScanning)
		{
			agent->doTurn(45);
			agent->setNeckAction( new Neck_TurnToRelative(90.0) );
			agent->doChangeView( rcsc::ViewWidth::NARROW );
		}
		else
		{
			Body_TurnToAngle(-150.0).execute(agent);
			agent->setNeckAction( new Neck_TurnToRelative(90.0) );
			agent->doChangeView( rcsc::ViewWidth::NARROW );
		}

		isLastActionScanning = true;

		Share::isScanning = true;

		return;
	}
	isLastActionScanning = false;


	double goToPointThr = 2.0;
	if (wm->self().pos().dist(homePos) < 5.0)
		goToPointThr = 0.5;

	int dash_power = dashPower(wm, homePos);
	if (isOffsideTrapSituation and homePos.x > wm->self().pos().x)
		dash_power = 100;

	if (Body_GoToPoint2008(homePos, goToPointThr, dash_power, true, false, true).execute(agent))
		dlog.addText(Logger::ROLE, "Going to HomePos %d", dash_power);
	else
	{
		double theta = (wm->self().pos() - Vector2D(-52.5, 0.0)).dir().degree() ;
		Vector2D turnPoint = wm->self().pos() + Vector2D::polar2vector(10.0, AngleDeg(theta + (theta > 0 ? +90 : -90)));
			
		Body_TurnToPoint(turnPoint).execute(agent);
		dlog.addText(Logger::ROLE, "Changing the body direction");
	}

	dlog.addText(Logger::ROLE, "Exiting DefenseBack::execute ------");
}

void DefenseBack::doKick(rcsc::PlayerAgent * agent)
{
	dlog.addText(Logger::ROLE, "Entering DefenseBack::doKick");

	if (DangerAreaClear().execute(agent))
	{
		dlog.addText(Logger::ROLE, "Danger Area Clear");
		return;
	}

	double * dist = new double;
	if (wm->getOpponentNearestTo(wm->ball().pos(), 5, dist) and *dist < (wm->ball().pos().x < -32.0 ? 3.0 : 2.0) and wm->ball().pos().x < 10.0)
	{
		Body_ClearBall2008().execute(agent);
		dlog.addText(Logger::ROLE, "clearing the ball!!!");
		return;
	}

	DefenseKickAction().CenterBack(agent);

	dlog.addText(Logger::ROLE, "Exiting DefenseBack::doKick");
}

void DefenseBack::doMove(rcsc::PlayerAgent * agent)
{
	dlog.addText(Logger::ROLE, "Entering DefenseBack::doMove");

	dlog.addText(Logger::ROLE, "Exiting DefenseBack::doMove");
}

int DefenseBack::dashPower(const WorldModel* wm, Vector2D homePos)
{
	int dashPower = min_max(50.0, homePos.dist(wm->self().pos()) * 10, 90.0);

	if (homePos.x > wm->self().pos().x)
		dashPower = 50;

	if (homePos.x < wm->self().pos().x)
		dashPower = 100;

	if (homePos.x < -36.0)
		dashPower = 100;

	dashPower = wm->self().getSafetyDashPower(dashPower);

	return dashPower;
}

bool DefenseBack::isOpponentFormationChanged(string str1, string str2)
{
	bool opponentFormationChanged = false ;
	vector<int> s1;
	vector<int> s2;

	dlog.addText(Logger::ROLE, str1.c_str());
	dlog.addText(Logger::ROLE, str2.c_str());

	for (uint i = 1 ; i < 7 ; i++)
		if (i != 4)
		{
			s1.push_back(str1[i]);
			s2.push_back(str2[i]);
			dlog.addText(Logger::ROLE, "## %d %d", s1[s1.size() - 1], s2[s2.size() - 1]);
		}

	dlog.addText(Logger::ROLE, "** %d: ", s1.size());
	dlog.addText(Logger::ROLE, "^^ %d: ", s2.size());

	for (uint i = 0 ; i < s1.size() ; i++)
	{
		bool opponentFound = false;
		for (uint j = 0 ; j < s2.size() ; j++)
			if (s1[i] == s2[j])
			{
				opponentFound = true;
			}
		if (!opponentFound)
			opponentFormationChanged = true;
	}

	return opponentFormationChanged;
}
