// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef __DEFENSE_BACK_H_
#define __DEFENSE_BACK_H_

#include <Plan.h>
#include <rcsc/geom/vector_2d.h>
#include <rcsc/player/ball_object.h>
#include <rcsc/player/player_object.h>
#include <map>

class DefenseBack : public Plan
{
public:
	DefenseBack(rcsc::Vector2D home_pos, int mark_target) : Plan(),
		homePos(home_pos),
		markTarget(mark_target)
	{
	}

	~DefenseBack()
	{
	}

	virtual void execute(rcsc::PlayerAgent * agent);

	static std::string name()
	{
		return std::string("DefenseBack");
	}

private:
	void doKick(rcsc::PlayerAgent * agent);
	void doMove(rcsc::PlayerAgent * agent);

	bool isOpponentFormationChanged(std::string str1, std::string str2);

	rcsc::Vector2D homePos;
	int markTarget;

	std::map<const rcsc::PlayerObject*, const rcsc::PlayerObject*> mMarkTable;

	int dashPower(const rcsc::WorldModel* wm, rcsc::Vector2D homePos);

	static bool isLastActionScanning;
};

#endif // __DEFENSE_BACK_H_
