// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef __DEFENSE_SYSTEM_H_
#define __DEFENSE_SYSTEM_H_

#include <Plan.h>
#include <rcsc/geom/vector_2d.h>


enum DefenseRole
{
	DR_BACK,

	// Normal defenders
	DR_CENTER,
	DR_TOP,
	DR_BOTTOM,

	// Defensive Midfielders
	DR_FRONT_CENTER,
	DR_FRONT_TOP,
	DR_FRONT_BOTTOM
};


class DefenseSystem : public Plan
{
	public:
		DefenseSystem() : Plan()
		{
		}

		~DefenseSystem()
		{
		}

		virtual void execute(rcsc::PlayerAgent * _agent);

		static std::string name()
		{
			return std::string("DefenseSystem");
		}

		static rcsc::Vector2D positioningTarget(const rcsc::WorldModel* wm, DefenseRole role);

	private:
		rcsc::PlayerAgent* agent;

		DefenseRole mRole;
		void determineRole();
};

#endif // __DEFENSE_SYSTEM_H_
