// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef __GOALIE_H
#define __GOALIE_H

#include <rcsc/game_time.h>
#include <rcsc/geom/vector_2d.h>

#include <Plan.h>

class Goalie : public Plan
{
private:
	rcsc::GameTime M_last_goalie_kick_time;

public:
	Goalie() : Plan(), M_last_goalie_kick_time(0, 0)
	{
	}

	~Goalie()
	{
	}

	virtual void execute(rcsc::PlayerAgent * _agent);

	static std::string name()
	{
		return std::string("Goalie");
	}

	static Plan * create()
	{
		return (new Goalie());
	}

private:
	rcsc::PlayerAgent* agent;

	void doKick();
	void doMove();

	bool doSideGuard();

	int getDashPower(rcsc::Vector2D homePos);

	rcsc::Vector2D positioningTarget();

	static bool isGuardExecuted;
};

#endif // __GOALIE_H_
