// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef __OFFENSE_SYSTEM_H_
#define __OFFENSE_SYSTEM_H_

#include <Plan.h>
#include <rcsc/geom/vector_2d.h>


enum OffenseRole
{
	// Normal attackers
	OR_CENTER,
	OR_TOP,
	OR_BOTTOM,

	// Offensive midfielders
	OR_BACK,
};


class OffenseSystem : public Plan
{
	public:
		OffenseSystem() : Plan()
		{
		}

		~OffenseSystem()
		{
		}

		virtual void execute(rcsc::PlayerAgent * _agent);

		static std::string name()
		{
			return std::string("OffenseSystem");
		}

		static rcsc::Vector2D positioningTarget(const rcsc::WorldModel* wm, OffenseRole role);

	private:
		rcsc::PlayerAgent* agent;

		OffenseRole mRole;
		void determineRole();
};

#endif // __OFFENSE_SYSTEM_H_
