// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef __SHARE_H_
#define __SHARE_H_

#include <rcsc/geom/vector_2d.h>

#include <Config.h>
#include <string>

#define CONFIG (*Share::configList)

class Share
{
	public:
		static void construct();
		static void destruct();

		static int currentPositionStyle;
		static int positionStyleToBeUsed;

		static int currentPassDecisionStyle;
		static int passDecisionStyleToBeUsed;

		static std::string nonPlayOnMarkMsg;

		static double lastSideDashAngle;
		static long lastSideDashCycle;

		static bool defensePassed;
		static double returnY;

		static std::string markSayMsg;
		static int markSayCycle;
		static int lastKickOffCycle;

		static std::string generatedMarkSayMsg;
		static int generatedMarkSayCycle;

		static ConfigList* configList;

		static bool isInterceptSituation;
		static bool checkInterceptSituation;

		static bool markLookMode;

		static bool isInterceptExecuted;
		static bool isMarkExecuted;

		static bool isLastMarkActionChasboondan;

		static rcsc::Vector2D lastOppRoute;
		static long lastOppRouteCycle;
		static double lastOppVel;
		static long lastInterceptBlockingCycle;

		static bool isScanning;

		static bool isLastActionIntercept;
		static bool isOurOwnIntercept;

		static bool isOppAlive[11];

		static double defenseLine;
};

#endif // __SHARE_H_
