/*
 *  Copyright 2002-2005, Mersad Team, Allameh Helli High School (NODET).
 *
 *  This program is free software, you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU Library General Public License for more details.
 *
 *  This file is created by: Ahmad Boorghany
 *
 *  Released on Monday 1 August 2005, 10 Mordad 1384 by Mersad RoboCup Team.
 *  For more information please read README file.
*/

#ifndef __DEGREE_H
#define __DEGREE_H

#include <rcsc/geom/vector_2d.h>

#define PI M_PI
#define DEG2RAD (PI/180)
#define RAD2DEG (180/PI)
#define SQRT_5 2.236067

namespace Degree
{
	extern float normalizeAngle(float angle);
	extern float absoluteAngle(float angle);
	extern bool isBetween(float angle1, float angle2, float checkAngle);
	extern float getDeltaAngle(float angle1,float angle2);

	extern float sin(float direction);
	extern float cos(float direction);
	extern float tan(float direction);
	extern float cot(float direction);
	extern float arcSin(float value);
	extern float arcCos(float value);
	extern float arcTan(float value);
	extern float arcCot(float value);
	extern float arcTan2(float y, float x);
	extern float arcCot2(float y, float x);
	extern float getDegree(rcsc::Vector2D pos1, rcsc::Vector2D pos2, rcsc::Vector2D pos3);
	extern rcsc::Vector2D turn(rcsc::Vector2D vec, float deg);
	extern float getShib(rcsc::Vector2D pos1, rcsc::Vector2D pos2);
}

#endif // __DEGREE_H
