// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#include "Ellipse.h"

using namespace std;
using namespace rcsc;

Ellipse::Ellipse()
{
	firstCenter = secondCenter = Vector2D( 0 , 0 );
	maxDist = 100;
}

Ellipse::Ellipse( Vector2D pointA , Vector2D pointB , float multiplier)
{
	if ( multiplier >= 1.f / 2.f )
		multiplier = 1.f / 2.f;
	maxDist = pointA.dist(pointB);
	float distFromCenter = ( maxDist / 2 ) * ( sqrt (1 - 4*multiplier*multiplier ) );
	Vector2D center = pointB + pointA;
	center /= 2.f;
	Vector2D khar = Vector2D::polar2vector ( distFromCenter , center.th() );
	firstCenter = center + khar;
	secondCenter = center - khar;
}

Ellipse::~Ellipse()
{
}

bool Ellipse::contains(Vector2D pos)
{
	float dist = firstCenter.dist(pos) + secondCenter.dist(pos);
	return ( dist <= ( maxDist + 0.5 ) );
}
