// -*-c++-*-

/*
 *Copyright:

 Copyright (C) ESKILAS TEAM

 This code is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef __W_MATCHING_H_
#define __W_MATCHING_H_

#include <vector>

const int maxn = 11;
const int inf = (1<<30) - 1;

class WMatching
{
	public:
		WMatching(int _n, std::vector< std::vector<int> > wvec);

		void read();
		bool dfs(int);
		bool find();
		void increase_matching();
		void calculate();

		int match[maxn];

	private:
		int n,u[maxn],v[maxn];
		int w[maxn][maxn];
		bool g[maxn][maxn];

		bool mark[maxn],matched[maxn];
};

#endif // __W_MATCHING_H_
